var _excluded = ["detail", "leftSpan", "rightSpan", "gutter", "style", "pagination", "header", "footer", "renderItem", "onRowClick", "paginationType", "listGap", "loadMoreData", "listHeight", "pcDetailModalDisplay", "padDetailModalDisplay", "mobilePadDetailModalDisplay", "children", "locale", "emptyButtons", "doubleList", "dataSource", "split", "isShowClode", "doubleListSource", "modalWrapStyle"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useCallback, useMemo, useState, useEffect, forwardRef, useImperativeHandle } from 'react';
import { Col, List, Row, Skeleton, Badge } from 'antd';
import { getUniqueId } from '@pisell/utils';
import Pagination from "../Pagination";
import { CloseOutlined } from '@ant-design/icons';
import InfiniteScroll from 'react-infinite-scroll-component';
import PisellEmpty from "./../pisellEmpty";
import { useResponsive } from "../../hooks";
import "./index.less";
var prefix = 'pisell-lowcode-';
var RecordView = function RecordView(props, ref) {
  var detail = props.detail,
    leftSpan = props.leftSpan,
    rightSpan = props.rightSpan,
    gutter = props.gutter,
    style = props.style,
    pagination = props.pagination,
    header = props.header,
    footer = props.footer,
    renderItem = props.renderItem,
    onRowClick = props.onRowClick,
    paginationType = props.paginationType,
    listGap = props.listGap,
    loadMoreData = props.loadMoreData,
    listHeight = props.listHeight,
    pcDetailModalDisplay = props.pcDetailModalDisplay,
    padDetailModalDisplay = props.padDetailModalDisplay,
    mobilePadDetailModalDisplay = props.mobilePadDetailModalDisplay,
    children = props.children,
    locale = props.locale,
    _props$emptyButtons = props.emptyButtons,
    emptyButtons = _props$emptyButtons === void 0 ? [] : _props$emptyButtons,
    _props$doubleList = props.doubleList,
    doubleList = _props$doubleList === void 0 ? false : _props$doubleList,
    _props$dataSource = props.dataSource,
    dataSource = _props$dataSource === void 0 ? [] : _props$dataSource,
    split = props.split,
    _props$isShowClode = props.isShowClode,
    isShowClode = _props$isShowClode === void 0 ? true : _props$isShowClode,
    _props$doubleListSour = props.doubleListSource,
    doubleListSource = _props$doubleListSour === void 0 ? [] : _props$doubleListSour,
    _props$modalWrapStyle = props.modalWrapStyle,
    modalWrapStyle = _props$modalWrapStyle === void 0 ? {} : _props$modalWrapStyle,
    others = _objectWithoutProperties(props, _excluded);
  useEffect(function () {
    document.body.id = 'body';
  }, []);
  var responsive = useResponsive();
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    detailModalShow = _useState2[0],
    setDetailModalShow = _useState2[1];
  useImperativeHandle(ref, function () {
    return {
      closeDetailModal: function closeDetailModal() {
        setDetailModalShow(false);
      }
    };
  });
  var detailModalDisplay = useMemo(function () {
    if (responsive === 'pc') {
      return pcDetailModalDisplay;
    } else if (responsive === 'ipad') {
      return padDetailModalDisplay;
    } else if (responsive === 'phone') {
      return mobilePadDetailModalDisplay;
    }
  }, [responsive, pcDetailModalDisplay, padDetailModalDisplay, mobilePadDetailModalDisplay]);
  var _footer = useMemo(function () {
    if (!(pagination && paginationType === 'default') && !footer) {
      return null;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, pagination && paginationType === 'default' && /*#__PURE__*/React.createElement(Pagination, _extends({
      showLessItems: true
    }, pagination)), footer);
  }, [pagination, footer]);
  var _renderItem = useCallback(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        setDetailModalShow(true);
        onRowClick(item);
      },
      style: {
        marginBottom: listGap
      }
    }, renderItem(item));
  }, [renderItem]);
  var _leftSpan = useMemo(function () {
    if (detailModalDisplay) {
      return 24;
    }
    return leftSpan;
  }, [leftSpan, detailModalDisplay]);
  var emptyDom = useMemo(function () {
    if (dataSource.length > 0) {
      return null;
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(PisellEmpty, {
      description: locale === null || locale === void 0 ? void 0 : locale.emptyText
      // image={Empty.PRESENTED_IMAGE_SIMPLE}
    }));
  }, [props.dataSource, locale, emptyButtons]);
  var scrollListId = useMemo(function () {
    return "scrollableDiv-".concat(getUniqueId());
  }, []);
  var list = useMemo(function () {
    if (paginationType === 'scroll') {
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "scroll-left-wrap")
      }, header && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "scroll-header-wrap")
      }, header), /*#__PURE__*/React.createElement("div", {
        id: scrollListId,
        style: {
          height: listHeight || 400,
          overflow: 'auto'
        },
        className: "".concat(prefix, "scroll-content-wrap")
      }, /*#__PURE__*/React.createElement(InfiniteScroll, {
        dataLength: props.dataSource.length,
        next: loadMoreData,
        hasMore: props.dataSource.length < ((pagination === null || pagination === void 0 ? void 0 : pagination.total) || 999999),
        loader: props.dataSource.length > 0 && /*#__PURE__*/React.createElement(Skeleton, {
          avatar: true,
          paragraph: {
            rows: 1
          },
          active: true,
          className: "".concat(prefix, "scroll-skeleton")
        }),
        scrollableTarget: scrollListId
      }, /*#__PURE__*/React.createElement(List, _extends({}, others, {
        dataSource: dataSource,
        renderItem: _renderItem
      }), emptyDom))), _footer && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "scroll-footer-wrap")
      }, _footer));
    }
    if (doubleList && doubleListSource.length > 0) {
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "record-view-double-list")
      }, doubleListSource.map(function (item) {
        var _item$dataSource = item.dataSource,
          dataSource = _item$dataSource === void 0 ? [] : _item$dataSource,
          title = item.title;
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefix, "record-view-double-list-item")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefix, "record-view-double-list-item-title")
        }, title, !!dataSource.length && /*#__PURE__*/React.createElement(Badge, {
          color: "var(--gray-50, #F9FAFB)",
          style: {
            marginLeft: 12,
            border: '1px solid var(--gray-200, #EAECF0)',
            color: 'var(--gray-700, #344054)'
          },
          count: dataSource.length
        })), /*#__PURE__*/React.createElement(List, _extends({}, others, {
          dataSource: dataSource,
          renderItem: _renderItem,
          footer: _footer
        }), emptyDom));
      }));
    }
    return /*#__PURE__*/React.createElement(List, _extends({}, others, {
      dataSource: dataSource,
      renderItem: _renderItem,
      header: header,
      footer: _footer
    }), emptyDom);
  }, [props, _renderItem, _footer]);
  return /*#__PURE__*/React.createElement(Row, {
    gutter: gutter,
    style: style,
    className: "".concat(prefix, "record-view")
  }, /*#__PURE__*/React.createElement(Col, {
    span: _leftSpan,
    className: "".concat(prefix, "record-view-left")
  }, list), !detailModalDisplay && /*#__PURE__*/React.createElement(Col, {
    span: rightSpan
  }, detail), detailModalShow && detailModalDisplay && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "detail-modal-wrap"),
    style: modalWrapStyle
  }, isShowClode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "modal-header")
  }, /*#__PURE__*/React.createElement(CloseOutlined, {
    className: "".concat(prefix, "close-icon"),
    onClick: function onClick() {
      return setDetailModalShow(false);
    }
  })), detail));
};
export default /*#__PURE__*/forwardRef(RecordView);